//  Copyright (C) 2000  MandrakeSoft S.A.
//
//    MandrakeSoft S.A.
//    43, rue d'Aboukir
//    75002 Paris - France
//    http://www.linux-mandrake.com/
//    http://www.mandrakesoft.com/
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

// This file (SOUNDOS2.CC) written and donated by Josef Drexler

#if defined(__OS2__)

#include "bochs.h"

#define WRITELOG        sb16->writelog
#define BOTHLOG(x)      (x)
#define MIDILOG(x)      ((bx_options.sb16.midimode>0?x:0x7f))
#define WAVELOG(x)      ((bx_options.sb16.wavemode>0?x:0x7f))

bx_sound_os2_c::bx_sound_os2_c(bx_sb16_c *sb16):bx_sound_output_c(sb16)
{
  this->sb16 = sb16;

  ismidiready = 1;
  iswaveready = 1;

  os2SoundCreate();
}

bx_sound_os2_c::~bx_sound_os2_c()
{
  os2SoundDestroy();
}

int bx_sound_os2_c::openmidioutput(char *device)
{
  return BX_SOUND_OUTPUT_OK;
}

int bx_sound_os2_c::sendmidicommand(int delta, int command, int length, Bit8u data[])
{
  return BX_SOUND_OUTPUT_OK;
}

int bx_sound_os2_c::closemidioutput()
{
  return BX_SOUND_OUTPUT_OK;
}

int bx_sound_os2_c::midiready()
{
  return BX_SOUND_OUTPUT_OK;
}

void bx_sound_os2_c::checkmidiready()
{
  ismidiready = midiready();
}

int bx_sound_os2_c::openwaveoutput(char *device)
{
  return BX_SOUND_OUTPUT_OK;
}

int bx_sound_os2_c::startwaveplayback(int frequency, int bits, int stereo, int format)
{
  if ( os2SoundBitsPerSample() != frequency || os2SoundSampleRate() != bits || os2SoundChannels() != stereo+1 )
     os2SoundOpen(bits,frequency,DATATYPE_WAVEFORM,stereo+1);
  return BX_SOUND_OUTPUT_OK;
}

int bx_sound_os2_c::sendwavepacket(int length, Bit8u data[])
{
  os2SoundPlay(length,(unsigned char *)data);
  return BX_SOUND_OUTPUT_OK;
}

int bx_sound_os2_c::stopwaveplayback()
{
  os2SoundStop();
  return BX_SOUND_OUTPUT_OK;
}

int bx_sound_os2_c::closewaveoutput()
{
  os2SoundStop ();
  os2SoundFreeBuffers ();
  os2SoundClose ();
  return BX_SOUND_OUTPUT_OK;
}

int bx_sound_os2_c::waveready()
{
  return os2SoundStopped() ? BX_SOUND_OUTPUT_OK : BX_SOUND_OUTPUT_ERR;
}

void bx_sound_os2_c::checkwaveready()
{
  iswaveready = waveready();
}

#endif // defined(__OS2__)
