//  Copyright (C) 2000  MandrakeSoft S.A.
//
//    MandrakeSoft S.A.
//    43, rue d'Aboukir
//    75002 Paris - France
//    http://www.linux-mandrake.com/
//    http://www.mandrakesoft.com/
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

#pragma pack(1)

#define INCL_DOS
#define INCL_DOSDEVIOCTL
#define INCL_DOSPROCESS
#define INCL_DOSMODULEMGR
#define INCL_DOSDEVICES
#define INCL_WINACCELERATORS
#define INCL_OS2MM
#include <os2.h>
#include <os2me.h>

#define _WINSOCKAPI_ 1

#define S_ISREG(x) 1
#define S_ISCHR(x) 1
#define true 1
#define false 0

#define PCI_VENDOR_ID 0x0
#define PCI_DEVICE_ID 0x2
#define PCI_COMMAND 0x4
#define PCI_REVISION_ID 0x8
#define PCI_BASE_ADDRESS_0 0x10
#define PCI_BASE_ADDRESS_1 0x14
#define SST1_PCI_INIT_ENABLE 0x40
#define SST1_PCI_BUS_SNOOP0 0x44
#define SST1_PCI_BUS_SNOOP1 0x48
#define SST1_PCI_SPECIAL1 0x40
#define SST1_PCI_SPECIAL2 0x44
#define SST1_PCI_SPECIAL3 0x48
#define SST1_PCI_SPECIAL4 0x54

#define PCI_VENDOR_ID_3DFX 0x121a
#define PCI_DEVICE_ID_3DFX_VOODOO  1
#define PCI_DEVICE_ID_3DFX_VOODOO2 2

typedef void BX_OUTPUTFUNC ( char *, ... );

BOOL os2PciQueryDevice( USHORT usDeviceID, USHORT usVendorID, UCHAR ucIndex, PUCHAR pucBus, PUCHAR pucDevFn );

BOOL os2PciQueryClass( USHORT usClass, USHORT usSubClass, PUCHAR pucBus, PUCHAR pucDevFn );

void os2PciRead( UCHAR ucBus, UCHAR ucDevFn, UCHAR ucIndex, PULONG pulData, UCHAR ucSize );

void os2PciWrite( UCHAR ucBus, UCHAR ucDevFn, UCHAR ucIndex, ULONG ulData, UCHAR ucSize );

ULONG os2PciFindCardType(int vendor, int device);

void os2PciReadAll( UCHAR ucBus, UCHAR ucDevFn, PCHAR pcData );

char *create_pmap( ULONG ulAddr, ULONG ulSize );

char _inb1 ( short sPort );

short _inw1 ( short sPort );

long _inl1 ( short sPort );

void _outb1 ( short sPort, char cValue );

void _outw1 ( short sPort, short sValue );

void _outl1 ( short sPort, long lValue );

void os2DiskCreate( char *pszPath, PUINT puiHeads, PUINT puiCylinders, PUINT puiSpt );

void os2DiskRead( long head, long cylinder, long sector, long size, char *buffer );

void os2DiskWrite( long head, long cylinder, long sector, long size, char *buffer );

void os2CdromCreate(char *pszDrive);

void os2CdromDestroy(void);

BOOL os2CdromInsert(void);

void os2CdromEject(void);

BOOL os2CdromReadTOC(unsigned char* buf, int* length, BOOL msf, int start_track);

ULONG os2CdromCapacity(void);

void os2CdromReadBlock(unsigned char* buf, int lba);

void os2SoundCreate(void);

void os2SoundDestroy(void);

BOOL os2SoundStopped(void);

void os2SoundOpen(int BitsPerSample, int SamplingRate, int DataFormat, int Channels);

int os2SoundBitsPerSample(void);

int os2SoundSampleRate(void);

int os2SoundChannels(void);

BOOL os2SoundPlay ( int length, unsigned char *data );

void os2SoundStop( void );

void os2SoundFreeBuffers( void );

void os2SoundClose( void );

char os2VideoMode( void );

void os2Open( BX_OUTPUTFUNC bx_func_printf );

void os2Close( void );

